Index: cprs/trunk/CPRS-Chart/fGraphs.pas
===================================================================
--- cprs/trunk/CPRS-Chart/fGraphs.pas	(revision 456)
+++ cprs/trunk/CPRS-Chart/fGraphs.pas	(revision 830)
@@ -7,8 +7,13 @@
   ExtCtrls, StdCtrls, ORCtrls, Menus, TeeProcs, TeEngine, Series, Chart, Math,
   ComCtrls, GanttCh, ClipBrd, StrUtils, ORFn, ORDtTmRng, DateUtils, Printers,
-  OleServer, Variants, Word97, Word2000, ArrowCha, ORDtTm, uGraphs;
+  OleServer, Variants, Word2000, ArrowCha, ORDtTm, uGraphs, fBase508Form
+  {$IFDEF VER140}
+  ,Word97;
+  {$ELSE}
+  ,WordXP, VA508AccessibilityManager;
+  {$ENDIF}
 
 type
-  TfrmGraphs = class(TForm)
+  TfrmGraphs = class(TfrmBase508Form)
     btnChangeSettings: TButton;
     btnClose: TButton;
@@ -28,33 +33,7 @@
     dlgDate: TORDateTimeDlg;
     lblDateRange: TLabel;
-    lblViewsBottom: TOROffsetLabel;
-    lblViewsTop: TOROffsetLabel;
-    lstAllTypes: TListBox;
-    lstCheck: TListBox;
-    lstData: TListBox;
-    lstDrugClass: TListBox;
-    lstItems: TListBox;
-    lstItemsTemp: TListBox;
-    lstMultiSpec: TListBox;
-    lstNonNumeric: TListBox;
-    lstScratchLab: TListBox;
-    lstScratchSwap: TListBox;
-    lstScratchTemp: TListBox;
-    lstSelCopyBottom: TListBox;
-    lstSelCopyTop: TListBox;
-    lstSpec1: TListBox;
-    lstSpec2: TListBox;
-    lstSpec3: TListBox;
-    lstSpec4: TListBox;
-    lstTemp: TListBox;
-    lstTempCheck: TListBox;
-    lstTestSpec: TListBox;
-    lstTypes: TListBox;
-    lstViews: TListBox;
-    lstZoomHistory: TListBox;
-    lvwItemsBottom: TListView;
-    lvwItemsTop: TListView;
-    mnumedsasgantt: TMenuItem;
-    mnumedsasganttvertheight: TMenuItem;
+    memBottom: TMemo;
+    memTop: TMemo;
+    mnuGraphData: TMenuItem;
     mnuPopGraph3D: TMenuItem;
     mnuPopGraphClear: TMenuItem;
@@ -65,4 +44,5 @@
     mnuPopGraphDualViews: TMenuItem;
     mnuPopGraphGradient: TMenuItem;
+    mnuPopGraphExport: TMenuItem;
     mnuPopGraphFixed: TMenuItem;
     mnuPopGraphHints: TMenuItem;
@@ -82,4 +62,5 @@
     mnuPopGraphToday: TMenuItem;
     mnuPopGraphValues: TMenuItem;
+    mnuPopGraphValueMarks: TMenuItem;
     mnuPopGraphVertical: TMenuItem;
     mnuPopGraphZoomBack: TMenuItem;
@@ -92,5 +73,4 @@
     pnlBottom: TPanel;
     pnlBottomRightPad: TPanel;
-    pnlData: TPanel;
     pnlDatelineBottom: TPanel;
     pnlDatelineBottomSpacer: TORAutoPanel;
@@ -117,18 +97,34 @@
     splItemsBottom: TSplitter;
     splItemsTop: TSplitter;
+    mnuTestCount: TMenuItem;
     timHintPause: TTimer;
-    lstSelPrevTop: TListBox;
-    lstSelPrevBottom: TListBox;
-    lstComp: TListBox;
-    pnlViewsTopSpacer: TPanel;
-    cboViewsTop: TORComboBox;
-    pnlViewsTopSpacerRight: TPanel;
-    pnlViewsBottomSpacer: TPanel;
-    cboViewsBottom: TORComboBox;
-    pnlViewsBottomSpacerRight: TPanel;
-    testcount1: TMenuItem;
+    mnuMHasNumeric1: TMenuItem;
+    mnuStandardDeviations: TMenuItem;
+    mnuInverseValues: TMenuItem;
+    mnuFunctions1: TMenuItem;
+    pcTop: TPageControl;
+    tsTopItems: TTabSheet;
+    tsTopViews: TTabSheet;
+    tsTopCustom: TTabSheet;
+    lvwItemsTop: TListView;
+    pcBottom: TPageControl;
+    tsBottomItems: TTabSheet;
+    tsBottomViews: TTabSheet;
+    tsBottomCustom: TTabSheet;
+    lvwItemsBottom: TListView;
+    mnuCustom: TMenuItem;
+    lstViewsTop: TORListBox;
+    lstViewsBottom: TORListBox;
+    memViewsTop: TRichEdit;
+    splViewsTop: TSplitter;
+    memViewsBottom: TRichEdit;
+    splViewsBottom: TSplitter;
+    mnuPopGraphViewDefinition: TMenuItem;
+    mnutest: TMenuItem;
+
     procedure FormCreate(Sender: TObject);
     procedure FormShow(Sender: TObject);
     procedure FormClose(Sender: TObject; var Action: TCloseAction);
+    procedure FormDestroy(Sender: TObject);
 
     procedure btnCloseClick(Sender: TObject);
@@ -137,14 +133,13 @@
 
     procedure chkDualViewsClick(Sender: TObject);
+    procedure chkItemsBottomClick(Sender: TObject);
+    procedure chkItemsBottomEnter(Sender: TObject);
     procedure chkItemsTopClick(Sender: TObject);
-    procedure chkItemsBottomClick(Sender: TObject);
-
-    procedure mnuMedsasganttClick(Sender: TObject);
     procedure mnuPopGraph3DClick(Sender: TObject);
     procedure mnuPopGraphClearClick(Sender: TObject);
-    procedure mnuPopGraphCopyClick(Sender: TObject);
     procedure mnuPopGraphDatesClick(Sender: TObject);
     procedure mnuPopGraphDetailsClick(Sender: TObject);
     procedure mnuPopGraphDualViewsClick(Sender: TObject);
+    procedure mnuPopGraphExportClick(Sender: TObject);
     procedure mnuPopGraphFixedClick(Sender: TObject);
     procedure mnuPopGraphGradientClick(Sender: TObject);
@@ -163,4 +158,5 @@
     procedure mnuPopGraphSwapClick(Sender: TObject);
     procedure mnuPopGraphTodayClick(Sender: TObject);
+    procedure mnuPopGraphValueMarksClick(Sender: TObject);
     procedure mnuPopGraphValuesClick(Sender: TObject);
     procedure mnuPopGraphHorizontalClick(Sender: TObject);
@@ -172,21 +168,21 @@
     procedure splItemsTopMoved(Sender: TObject);
 
-    procedure GetSize;
-    procedure SetSize;
-
+    procedure lvwItemsBottomChange(Sender: TObject; Item: TListItem;
+      Change: TItemChange);
     procedure lvwItemsBottomClick(Sender: TObject);
     procedure lvwItemsBottomColumnClick(Sender: TObject; Column: TListColumn);
     procedure lvwItemsBottomCompare(Sender: TObject; Item1,
       Item2: TListItem; Data: Integer; var Compare: Integer);
+    procedure lvwItemsTopChange(Sender: TObject; Item: TListItem;
+      Change: TItemChange);
     procedure lvwItemsTopClick(Sender: TObject);
     procedure lvwItemsTopColumnClick(Sender: TObject; Column: TListColumn);
     procedure lvwItemsTopCompare(Sender: TObject; Item1, Item2: TListItem;
       Data: Integer; var Compare: Integer);
+    procedure lvwItemsTopKeyDown(Sender: TObject; var Key: Word;
+      Shift: TShiftState);
 
     procedure cboDateRangeChange(Sender: TObject);
-    procedure cboViewsBottomChange(Sender: TObject);
-    procedure cboViewsTopChange(Sender: TObject);
-
-    procedure pnlScrollTopBaseResize(Sender: TObject);
+    procedure cboDateRangeDropDown(Sender: TObject);
 
     procedure chartBaseClickLegend(Sender: TCustomChart;
@@ -196,4 +192,6 @@
     procedure chartBaseMouseDown(Sender: TObject; Button: TMouseButton;
       Shift: TShiftState; X, Y: Integer);
+    procedure chartBaseMouseUp(Sender: TObject; Button: TMouseButton;
+      Shift: TShiftState; X, Y: Integer);
     procedure chartBaseMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
     procedure serDatelineTopGetMarkText(Sender: TChartSeries;
@@ -202,33 +200,52 @@
     procedure ChartOnUndoZoom(Sender: TObject);
     procedure ChartOnZoom(Sender: TObject);
+    procedure DateSteps(dateranges: string);
     procedure DisplayData(aSection: string);
+    procedure DisplayDataInfo(aScrollBox: TScrollBox; aMemo: TMemo);
+    procedure GraphSwap(bottomview, topview: integer);
+    procedure GraphSwitch(bottomview, topview: integer);
     procedure HideDates(aChart: TChart);
+    procedure LabelClicks(aChart: TChart; aSeries: TChartSeries; lbutton: boolean; tmp: integer);
+    procedure MouseClicks(aChart: TChart; lbutton: boolean; X, Y: Integer);
+    procedure SeriesClicks(aChart: TChart; aSeries: TChartSeries; aIndex: integer; lbutton: boolean);
+    procedure SetupFields(settings: string);
     procedure SourcesDefault;
     procedure StayOnTop;
-
-    procedure timHintPauseTimer(Sender: TObject);
+    procedure FormatHint(var astring: string);
+
     procedure ZoomUpdate;
     procedure ZoomUpdateInfo(SmallTime, BigTime: TDateTime);
     procedure ZoomTo(SmallTime, BigTime: TDateTime);
-    procedure lvwItemsTopChange(Sender: TObject; Item: TListItem;
-      Change: TItemChange);
-    procedure lvwItemsTopKeyDown(Sender: TObject; var Key: Word;
-      Shift: TShiftState);
-    procedure lvwItemsBottomChange(Sender: TObject; Item: TListItem;
-      Change: TItemChange);
-    procedure testcount1Click(Sender: TObject);
-    procedure cboDateRangeDropDown(Sender: TObject);
-    procedure cboViewsTopDropDown(Sender: TObject);
-    procedure cboViewsTopDropDownClose(Sender: TObject);
-    procedure cboViewsBottomDropDown(Sender: TObject);
-    procedure cboViewsBottomDropDownClose(Sender: TObject);
-    procedure FormDestroy(Sender: TObject);
+
+    procedure lvwItemsBottomEnter(Sender: TObject);
     procedure lvwItemsTopEnter(Sender: TObject);
-    procedure lvwItemsBottomEnter(Sender: TObject);
-    procedure chkItemsBottomEnter(Sender: TObject);
-    procedure cboViewsBottomEnter(Sender: TObject);
+
+    procedure memBottomEnter(Sender: TObject);
+    procedure memBottomExit(Sender: TObject);
+    procedure memBottomKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
+    procedure memTopEnter(Sender: TObject);
+    procedure memTopExit(Sender: TObject);
+    procedure memTopKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
+
+    procedure pnlScrollTopBaseResize(Sender: TObject);
+    procedure timHintPauseTimer(Sender: TObject);
+
+    procedure GetSize;
+    procedure SetSize;
+    procedure mnuGraphDataClick(Sender: TObject);
+    procedure mnuCustomClick(Sender: TObject);
+    procedure lstViewsTopChange(Sender: TObject);
+    procedure lstViewsBottomChange(Sender: TObject);
+    procedure mnuMHasNumeric1Click(Sender: TObject);
+    procedure lstViewsTopEnter(Sender: TObject);
+    procedure lstViewsBottomEnter(Sender: TObject);
+    procedure mnuPopGraphViewDefinitionClick(Sender: TObject);
+    procedure lstViewsTopMouseDown(Sender: TObject; Button: TMouseButton;
+      Shift: TShiftState; X, Y: Integer);
+    procedure splViewsTopMoved(Sender: TObject);
+    procedure lstViewsBottomMouseDown(Sender: TObject; Button: TMouseButton;
+      Shift: TShiftState; X, Y: Integer);
 
   private
-    { Private declarations }
     FBSortAscending: boolean;
     FBSortCol: integer;
@@ -242,11 +259,16 @@
     FBHighTime, FBLowTime: Double;
     FCreate: boolean;
+    FDisplayFreeText: boolean;
+    FFastData: boolean;
+    FFastItems: boolean;
+    FFastLabs: boolean;
+    FFastTrack: boolean;
     FFirstClick: boolean;
     FFirstSwitch: boolean;
     FGraphClick: TCustomChart;
     FGraphSeries: TChartSeries;
-    FGraphValueIndex: integer;
     FGraphSetting: TGraphSetting;
     FGraphType: char;
+    FGraphValueIndex: integer;
     FItemsSortedTop: boolean;
     FItemsSortedBottom: boolean;
@@ -254,7 +276,7 @@
     FMTimestamp: string;
     FMToday: TFMDateTime;
-    FMyProfiles, FProfiles: TStringList;
     FNonNumerics: boolean; // used with pnlItemsTop.Tag & pnlItemsBottom.Tag
     FOnLegend:  integer;
+    FOnMark: boolean;
     FOnSeries: integer;
     FOnValue: integer;
@@ -264,4 +286,5 @@
     FSourcesDefault: TStrings;
     FTHighTime, FTLowTime: Double;
+    FTooManyItems: boolean;
     FWarning: boolean;
     FX, FY: integer;
@@ -269,4 +292,5 @@
     FYMaxValue: Double;
 
+    procedure AddOnLabGroups(aListBox: TORListBox; personien: integer);
     procedure AdjustTimeframe;
     procedure AllTypeDate(aType, aTypeName, firstline, secondline: string; aDate, aDate2: double);
@@ -275,58 +299,98 @@
     procedure AutoSelect(aListView: TListView);
     procedure BaseResize(aScrollBox: TScrollBox);
+    procedure BorderValue(var bordervalue: double; value: double);
     procedure BottomAxis(aScrollBox: TScrollBox);
+    procedure BPAdd(itemvalue: string; adatetime: TDateTime; var fixeddatevalue: double; serLine, serBPDiastolic, serBPMean: TLineSeries);
+    procedure BPCheck(aChart: TChart; aFileType: string; serLine, serBPDiastolic, serBPMean: TLineSeries);
     procedure ChangeStyle;
+    procedure ChartColor(aColor: TColor);
     procedure ChartStyle(aChart: TChart);
+    procedure CheckMedNum(var typenum: string; aSeries: TChartSeries);
     procedure CheckProfile(var aProfile: string; var Updated: boolean);
     procedure CheckToAddData(aListView: TListView; aSection, TypeToCheck: string);
+    procedure CreateExcelPatientHeader(var HeaderList: TStringList; PageTitle, DateRange: string);
     procedure CreatePatientHeader(var HeaderList: TStringList; PageTitle, Warning, DateRange: string);
     procedure DateRangeItems(oldestdate, newestdate: double; filenum: string);
-    procedure UpdateView(filename, filenum, itemnum, aString: string; aListView: TListView);
     procedure DisplayType(itemtype, displayed: string);
+    procedure FastLab(aList: TStringList);
     procedure FillViews;
     procedure FilterListView(oldestdate, newestdate: double);
     procedure FixedDates(var adatetime, adatetime1: TDateTime);
     procedure GetData(aString: string);
+    procedure GraphBoundry(singlepoint: boolean);
+    procedure GraphFooter(aChart: TChart; datediff: integer; aDate: TDateTime);
     procedure HideGraphs(action: boolean);
     procedure HighLow(fmtime, fmtime1: string; aChart: TChart; var adatetime, adatetime1: TDateTime);
     procedure InactivateHint;
+    procedure InfoMessage(aCaption: string; aColor: TColor; aVisible: boolean);
     procedure ItemCheck(aListView: TListView; aItemName: string;
       var aNum: integer; var aTypeItem: string);
+    procedure ItemDateRange(Sender: TCustomChart);
     procedure ItemsClick(Sender: TObject; aListView, aOtherListView: TListView;
-      aCheckBox: TCheckBox; aComboBox: TORComboBox; aList: TListBox; aSection: string);
-    procedure ItemDateRange(Sender: TCustomChart);
-    procedure LabData(aItemType, aItemName, aSection: string);
+      aCheckBox: TCheckBox; aListBox: TORListBox; aList: TStrings; aSection: string);
+    procedure LabAdd(aListView: TListView; filename: string; aIndex, oldlisting: integer; selectlab: boolean);
+    procedure LabCheck(aListView: TListView; aItemType: string; var oldlisting: integer);
+    procedure LabData(aItemType, aItemName, aSection: string; getdata: boolean);
     procedure LoadDateRange;
     procedure LoadDisplayCheck(typeofitem: string; var updated: boolean);
     procedure LoadType(itemtype, displayed: string);
     procedure NextPointerStyle(aSeries: TChartSeries; aSerCnt: integer);
+    procedure NonNumSave(aChart: TChart; aTitle, aSection: string; adatetime: TDateTime;
+      var noncnt: integer; newcnt, aIndex: integer);
+    procedure NotifyApps(aList: TStrings);
+    procedure NumAdd(serLine: TLineSeries; value: double; adatetime: TDateTime;
+      var fixeddatevalue, hi, lo: double; var high, low: string);
     procedure OneDayTypeDetails(aTypeItem: string);
+    procedure PadNonNum(aChart: TChart; aSection: string; var listofseries: string; var bmax, tmax: integer);
+    procedure PainAdd(serBlank: TPointSeries);
     procedure RefUnits(aItem, aSpec: string; var low, high, units: string);
-    procedure ResetSpec(aListBox: TListBox; aItemNum, aNewItemNum, aNewItemName, aNewString: string);
-    procedure TempCheck(typeitem: string; var levelseq: double);
-    procedure SelCopy(aListView: TListView; aListBox: TListBox);
-    procedure SelReset(aListbox: TListBox; aListView: TListView);
+    procedure ResetSpec(aList: TStrings; aItemNum, aNewItemNum, aNewItemName, aNewString: string);
+    procedure ResultValue(var resultstring, seriestitle: string; typenum, typeitem: string;
+      Sender: TCustomChart; aSeries: TChartSeries; ValueIndex, SeriesNum: Integer; var OKToUse: boolean);
+    procedure SelCopy(aListView: TListView; aList: TStrings);
+    procedure SelReset(aList: TStrings; aListView: TListView);
     procedure SelectItem(aListView: TListView; typeitem: string);
+    procedure SeriesForLabels(aChart: TChart; aID: string; pad: double);
     procedure SetProfile(aProfile, aName: string; aListView: TListView);
     procedure SizeDates(aChart: TChart; aSmallTime, aBigTime: TDateTime);
     procedure SizeTogether(onlylines, nolines, anylines: Boolean; aScroll: TScrollBox;
       aChart: TChart; aPanel, aPanelBase: TPanel; portion: Double);
-    procedure ViewsChange(aListView: TListView; aComboBox: TORComboBox; aSection: string);
-
+    procedure SpecCheck(var spec1, spec2, spec3, spec4: string; var singlespec: boolean);
+    procedure SpecSet(var spec1, spec2, spec3, spec4: string; aItemType, aItemName: string);
+    procedure SplitClick;
+    procedure SortListView;
+    procedure StackNonNum(astring: string; var offset, bmax, tmax: integer; var blabelon, tlabelon: boolean);
+    procedure TempCheck(typeitem: string; var levelseq: double);
+    procedure TempData(aStringList: TStringList; aType: string; dt1, dt2: double);
+    procedure UpdateView(filename, filenum, itemnum, aString: string; aListView: TListView);
+    procedure ValueDates(aSeries: TChartSeries; ValueIndex: Integer; var resultdate, otherdate: string);
+    procedure ViewsChange(aListView: TListView; aListBox: TORListBox; aSection: string);
+
+    procedure MakeSeparate(aScrollBox: TScrollBox; aListView: TListView; aPadPanel: TPanel; section: string);
+    procedure MakeSeparateItems(aScrollBox: TScrollBox; aListView: TListView; section: string);
+    procedure MakeTogether(aScrollBox: TScrollBox; aListView: TListView; aPadPanel: TPanel; section: string);
+    procedure MakeTogetherMaybe(aScrollBox: TScrollBox; aListView: TListView; aPadPanel: TPanel; section: string);
+    procedure MakeTogetherNoLines(aListView: TListView; section: string);
+    procedure MakeTogetherOnlyLines(aListView: TListView; section: string; aChart: TChart);
+    procedure MakeTogetherAnyLines(aListView: TListView; section: string; aChart: TChart);
+
+    procedure MakeChart(aChart: TChart; aScrollBox: TScrollBox);
+    procedure MakeComments(aChart: TChart);
     procedure MakeDateline(section, aTitle, aFileType: string; aChart: TChart; graphtype: integer;
-      var bcnt, pcnt, gcnt, vcnt, acnt: integer);
-    procedure MakeSeparate(aScrollBox: TScrollBox; aListView: TListView; aPadPanel: TPanel; section: string);
-    procedure MakeTogether(aScrollBox: TScrollBox; aListView: TListView; aPadPanel: TPanel; section: string);
-
-    procedure MakeAGanttSeries(aChart: TChart; aTitle, aFileType: string; var aSerCnt: integer);
-    procedure MakeArrowSeries(aChart: TChart; aTitle, aFileType: string; var aSerCnt: integer);
+      var bcnt, pcnt, gcnt, vcnt: integer);
+    procedure MakeNonNumerics(aChart: TChart);
+    procedure MakeNonNumSeries(aChart: TChart; padvalue, highestvalue, lowestvalue: double; listofseries, section: string);
+    procedure MakeOtherSeries(aChart: TChart);
+    procedure MakeSeriesInfo(aChart: TChart; aSeries: TChartSeries; aTitle, aFileType: string; aSerCnt: integer);
+    procedure MakeSeriesPoint(aChart: TChart; aPointSeries: TPointSeries);
+    procedure MakeSeriesRef(aChart: TChart; aTest, aRef: TLineSeries; aTitle, aValue: string; aDate: double);
+    procedure MakeSeriesBP(aChart: TChart; aTest, aBP: TLineSeries; aFileType: string);
+
     procedure MakeBarSeries(aChart: TChart; aTitle, aFileType: string; var aSerCnt: integer);
-    procedure MakeGanttSeries(aChart: TChart; aTitle, aFileType: string; var aSerCnt: integer);
-    procedure MakeLineSeries(aChart: TChart; aTitle, aFileType: string; var aSerCnt, aNonCnt: integer; multiline: boolean);
-    procedure MakeManyGanttSeries(aChart: TChart; aTitle, aFileType: string; var aSerCnt: integer);  // good one
+    procedure MakeLineSeries(aChart: TChart; aTitle, aFileType, section: string;
+      var aSerCnt, aNonCnt: integer; multiline: boolean);
+    procedure MakeGanttSeries(aChart: TChart; aTitle, aFileType: string; var aSerCnt: integer);  // good one
     procedure MakePointSeries(aChart: TChart; aTitle, aFileType: string; var aSerCnt: integer);
     procedure MakeVisitGanttSeries(aChart: TChart; aTitle, aFileType: string; var aSerCnt: integer);
-    procedure MakeWeightedArrowSeries(aChart: TChart; aTitle, aFileType: string; var aSerCnt: integer);
-    procedure MakeWeightedGanttSeries(aChart: TChart; aTitle, aFileType: string; var aSerCnt: integer);
 
     function BPValue(aDateTime: TDateTime): string;
@@ -341,14 +405,21 @@
     function ItemName(filenum, itemnum: string): string;
     function NextColor(aCnt: integer): TColor;
-    function PortionSize(lcnt, pcnt, gcnt, vcnt, bcnt, acnt: integer): double;
+    function NonNumText(listnum, seriesnum, valueindex: integer): string;
+    function PadLeftEvent(aWidth: integer): integer;
+    function PadLeftNonNumeric(aWidth: integer): integer;
+    function PortionSize(lcnt, pcnt, gcnt, vcnt, bcnt: integer): double;
+    function ProfileName(aProfile, aName, aString: string): string;
     function SelectRef(aRef: string): string;
+    function SingleLabTest(aListView: TListView): boolean;
     function StdDev(value, high, low: double): double;
+    function TitleInfo(filetype, typeitem, caption: string): string;
     function TypeIsDisplayed(itemtype: string): boolean;
     function TypeIsLoaded(itemtype: string): boolean;
-    function Vfactor(aTitle: string): double;
-    function ValueText(Sender: TCustomChart; Series: TChartSeries; ValueIndex: Integer): string;
-
+    function TypeString(filenum: string): string;
+    function ValueText(Sender: TCustomChart; aSeries: TChartSeries; ValueIndex: Integer): string;
+  protected
+    procedure UpdateAccessabilityActions(var Actions: TAccessibilityActions); override;
   public
-    { Public declarations }
+    procedure DateDefaults;
     procedure InitialData;
     procedure Initialize;
@@ -356,5 +427,8 @@
     procedure LoadListView(aList: TStrings);
     procedure SourceContext;
+    procedure Switch;
+    procedure ViewDefinition(profile: string; amemo: TRichEdit);
     procedure ViewSelections;
+    procedure DisplayFreeText(aChart: TChart);
     procedure SetFontSize(FontSize: integer);
     function FMToDateTime(FMDateTime: string): TDateTime;
@@ -369,7 +443,10 @@
 implementation
 
-uses fGraphSettings, fGraphProfiles, rGraphs,
-  ComObj, ActiveX, ShellAPI, fFrame, uCore, rCore, fRptBox, fReports,
-  uFormMonitor;
+uses fGraphSettings, fGraphProfiles, fGraphData, fGraphOthers, rGraphs,
+  ComObj, ActiveX, ShellAPI, fFrame, uCore, rCore, uConst, fRptBox, fReports,
+  uFormMonitor, VAUtils
+  { TODO -oRV -cWVEHR Long Age : Changed to use long age }
+  , rWVEHR;
+
 
 {$R *.DFM}
@@ -384,65 +461,19 @@
 var
   i: integer;
-  dfntype, listline, settings, settings1, t1, t2: string;
-  aList: TStrings;
-begin
-  FMToday := DateTimeToFMDateTime(Date);
-  FHintWinActive := false;
-  FHintStop := false;
-  FNonNumerics := false;
-  FMouseDown := false;
-  FItemsSortedTop := false;
-  FItemsSortedBottom := false;
-  FRetainZoom := false;
-  FFirstClick := true;
-  FArrowKeys := false;
-  FCreate := true;
-  FGraphType := Char(32);
-  aList := TStringList.Create;
-  FastAssign(rpcGetGraphSettings, aList);
+  dfntype, listline, settings, settings1: string;
+begin
   btnClose.Tag := 0;
-  if aList.Count < 1 then
+  settings := GetCurrentSetting;
+  if (length(settings) < 1) then
   begin
     Screen.Cursor := crDefault;
-    showmessage('CPRS is not configured for graphing.');
+    ShowMsg(TXT_NOGRAPHING);
     btnClose.Tag := 1;
-    FreeAndNil(aList);
     Close;
     Exit;
   end;
-  t1 := aList[0]; t2 := aList[1];   // hint are current, t1 are personal, t2 public settings
-  if length(frmFrame.mnuToolsGraphing.Hint) > 0 then settings := frmFrame.mnuToolsGraphing.Hint
-  else if length(t1) > 0 then settings := t1
-  else settings := t2;
-  SetPiece(settings, '|', 8, Piece(t2, '|', 8)); //??????????
-  frmFrame.mnuToolsGraphing.Hint := settings;
+  SetupFields(settings);
   settings1 := Piece(settings, '|', 1);
-  FSources := TStringList.Create;
-  FSourcesDefault := TStringList.Create;
-  FMyProfiles := TStringList.Create;
-  FProfiles := TStringList.Create;
-  FYMinValue := 0;
-  FYMaxValue := 0;
-  FTHighTime := 0;
-  FTLowTime := BIG_NUMBER;
-  FBHighTime := 0;
-  FBLowTime := BIG_NUMBER;
   pnlInfo.Caption := TXT_INFO;
-  FOnLegend := BIG_NUMBER;
-  FOnSeries := BIG_NUMBER;
-  FOnValue := BIG_NUMBER;
-  FHintWin := THintWindow.Create(self);
-  FHintWin.Color := clInfoBk;
-  FHintWin.Canvas.Font.Color := clInfoBk;
-  FX := 0; FY :=0;
-  FastAssign(rpcGetTypes('0', false), lstAllTypes.Items);
-  for i := 0 to lstAllTypes.Items.Count - 1 do
-  begin
-    listline := lstAllTypes.Items[i];
-    dfntype := UpperCase(Piece(listline, '^', 1));
-    SetPiece(listline, '^', 1, dfntype);
-    lstAllTypes.Items[i] := listline;
-  end;
-  FGraphSetting := GraphSettingsInit(settings);
   for i := 0 to BIG_NUMBER do
   begin
@@ -460,9 +491,48 @@
   chartDatelineBottom.Gradient.StartColor := clWindow;
   LoadDateRange;
-  chkItemsTop.Checked := true;
-  chkItemsBottom.Checked := true;
-  FastAssign(rpcGetTestSpec, lstTestSpec.Items);
+  //chkItemsTop.Checked := true;
+  //chkItemsBottom.Checked := true;
   FillViews;
-  FreeAndNil(aList);
+  pcTop.ActivePage := tsTopItems;
+  pcBottom.ActivePage := tsBottomItems;
+end;
+
+procedure TfrmGraphs.SetupFields(settings: string);
+begin
+  FArrowKeys := false;
+  FBHighTime := 0;
+  FBLowTime := BIG_NUMBER;
+  FCreate := true;
+  FDisplayFreeText := true;
+  FGraphType := Char(32);
+  FFirstClick := true;
+  FFirstSwitch := true;
+  FGraphSetting := GraphSettingsInit(settings);
+  FHintStop := false;
+  FHintWin := THintWindow.Create(self);
+  FHintWin.Color := clInfoBk;
+  FHintWin.Canvas.Font.Color := clInfoBk;
+  FHintWinActive := false;
+  FItemsSortedBottom := false;
+  FItemsSortedTop := false;
+  FMouseDown := false;
+  FMTimestamp := floattostr(FMNow);
+  FMToday := DateTimeToFMDateTime(Date);
+  FNonNumerics := false;
+  FOnLegend := BIG_NUMBER;
+  FOnMark := false;
+  FOnSeries := BIG_NUMBER;
+  FOnValue := BIG_NUMBER;
+  FPrevEvent := '';
+  FRetainZoom := false;
+  FSources := TStringList.Create;
+  FSourcesDefault := TStringList.Create;
+  FTHighTime := 0;
+  FTLowTime := BIG_NUMBER;
+  FWarning := false;
+  FTooManyItems := false;
+  FX := 0; FY :=0;
+  FYMinValue := 0;
+  FYMaxValue := 0;
 end;
 
@@ -470,16 +540,8 @@
 var
   i: integer;
-  dfntype, listline, settings, settings1, t1, t2: string;
-  aList: TStrings;
-begin
-  aList := TStringList.Create;
-  FastAssign(rpcGetGraphSettings, aList);
-  t1 := aList[0]; t2 := aList[1];   // t1 are personal, t2 public settings
-  if length(frmFrame.mnuToolsGraphing.Hint) > 0 then settings := frmFrame.mnuToolsGraphing.Hint
-  else if length(t1) > 0 then settings := t1
-  else settings := t2;
-  SetPiece(settings, '|', 8, Piece(t2, '|', 8));
+  dfntype, listline, settings, settings1: string;
+begin
+  settings := GetCurrentSetting;
   settings1 := Piece(settings, '|', 1);
-  FGraphSetting := GraphSettingsInit(settings);
   for i := 0 to BIG_NUMBER do
   begin
@@ -489,9 +551,8 @@
     FSourcesDefault.Add(listline);
   end;
-  FreeAndNil(aList);
 end;
 
 procedure TfrmGraphs.Initialize;
-var
+var                                        // from fFrame and fReports
   i: integer;
   rptview1, rptview2, rptviews: string;
@@ -499,5 +560,5 @@
   InitialData;
   SourceContext;
-  LoadListView(lstItems.Items);
+  LoadListView(GtslItems);
   if pnlMain.Tag > 0 then
   begin
@@ -509,10 +570,14 @@
       if length(rptview1) > 0 then
       begin
-        for i := 0 to cboViewsTop.Items.Count - 1 do
-        if Piece(cboViewsTop.Items[i], '^', 2) = rptview1 then
+        //pcTop.ActivePage := tsTopViews;
+        lstViewsTop.Tag := 0;
+        for i := 0 to lstViewsTop.Items.Count - 1 do
+        if Piece(lstViewsTop.Items[i], '^', 2) = rptview1 then
         begin
-          cboViewsTop.ItemIndex := i;
+          lstViewsTop.ItemIndex := i;
           break;
         end;
+        if lstViewsTop.ItemIndex < 0 then
+          lvwItemsTopClick(self);
       end;
       if length(rptview2) > 0 then
@@ -520,67 +585,33 @@
         chkDualViews.Checked := true;
         chkDualViewsClick(self);
-        for i := 0 to cboViewsBottom.Items.Count - 1 do
-        if Piece(cboViewsBottom.Items[i], '^', 2) = rptview2 then
+        //pcBottom.ActivePage := tsBottomViews;
+        lstViewsBottom.Tag := 0;
+        for i := 0 to lstViewsBottom.Items.Count - 1 do
+        if Piece(lstViewsBottom.Items[i], '^', 2) = rptview2 then
         begin
-          cboViewsBottom.ItemIndex := i;
+          lstViewsBottom.ItemIndex := i;
           break;
         end;
+        if lstViewsBottom.ItemIndex < 0 then
+          lvwItemsBottomClick(self);
       end;
     end;
-  end;
-  if cboViewsTop.ItemIndex > -1 then
-    cboViewsTopChange(self)
+    pnlMain.Tag := 0;
+    cboDateRangeChange(self);
+    exit;
+  end;
+  if lstViewsTop.ItemIndex > -1 then
+    lstViewsTopChange(self)
   else
     lvwItemsTopClick(self);
-  if cboViewsBottom.ItemIndex > -1 then
-    cboViewsbottomChange(self)
+  if lstViewsBottom.ItemIndex > -1 then
+    lstViewsbottomChange(self)
   else
     lvwItemsBottomClick(self);
-  if pnlMain.Tag > 0 then
-  begin
-    pnlMain.Tag := 0;
-    cboDateRangeChange(self);
-  if cboViewsTop.ItemIndex > -1 then
-    cboViewsTopChange(self)
-  else
-    lvwItemsTopClick(self);
-  if cboViewsBottom.ItemIndex > -1 then
-    cboViewsbottomChange(self)
-  else
-    lvwItemsBottomClick(self);
-  end;
 end;
 
 procedure TfrmGraphs.InitialRetain;
-//var
-  //i: integer;
-begin
-  {//
-  allview=false
-  fullview=false
-  noview=true
-  go thru items
-        if selected
-                if view
-                        noview=false
-                else
-                        allview=false
-
-        else
-                if view
-                        allview=false
-                        fullview=false
-                        noview=false
-                else
-                        //
-  if noview
-        //
-  if allview
-        //
-  if fullview
-        //
-  else //partial view
-        //
-  //}
+begin
+  // from fFrame
 end;
 
